Subject: bug#17035: [PATCH] chmod -c -R produces errors with special permissions

From: Pádraig Brady <[email-masked]>
Date: Tue, 18 Mar 2014 23:41:19 +0000

On 03/18/2014 10:18 PM, Bernhard Voelker wrote:
> On 03/18/2014 07:45 PM, Pádraig Brady wrote:
>> The fix looks good.  It seems this bug was introduced
>> with the change to FTS in 5.1.0 (released Dec 2003)
> 
> Wasn't it commit v5.2.1-690-gbc580f6?

I think that restricted the issue to if (new_mode & (S_ISUID | S_ISGID | S_ISVTX))
but the stat on the relative name was there previously?

> One question: I did not dig into this deeper yet, but what exactly
> is the connection between "directory with special permissions"
> vs. "stat()ing the wrong file"?
> I'm asking because incidentally yesterday I saw the same warning
> from "chmod -R -c" when playing with recursive bind-mounts, i.e.,
> there were no files or directories with special bits set.

Interesting. Looking at the code seems that message
is restricted to the above condition where those bits are set.
Can you reproduce?

thanks,
Pádraig.